// Copyright (c) 2016 Citrix Systems, Inc. All Rights Reserved.
// You may only reproduce, distribute, perform, display, or prepare derivative works of this file pursuant to a valid license from Citrix.
// THIS SAMPLE CODE IS PROVIDED BY CITRIX "AS IS" AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.

#pragma once

#ifdef DEBUG
#define TRACING_ENABLED 1
#else
#define TRACING_ENABLED 0
#endif

#define TRACE(format)                                               \
    do {                                                            \
        if (TRACING_ENABLED) {                                      \
            fprintf(stderr, "CID Plugin: %s:%d:%s(): " format "\n", \
            __FILE__, __LINE__, __func__);                          \
        }                                                           \
    } while (0)

#define TRACE_WITH_ARGS(format, ...)                                \
    do {                                                            \
        if (TRACING_ENABLED) {                                      \
            fprintf(stderr, "CID Plugin: %s:%d:%s(): " format "\n", \
            __FILE__, __LINE__, __func__, __VA_ARGS__);             \
        }                                                           \
    } while (0)

#include <string>
#include <vector>

std::string GetHomeDirectory();

std::string GetIcaRoot();

bool LoadFileIntoVector(const std::string& filePath, /* out */ std::vector<char>& outData);

void DataToBase64(const std::vector<char>& data, /* out */ std::string& outBase64);

void ParseUrl(const std::string& urlString,
              /* out */ std::string& outProtocol,
              /* out */ std::string& outHostName,
              /* out */ unsigned int& outPort,
              /* out */ std::string& outPath,
              /* out */ std::string& outQuery);

bool CrackUrl(const std::string &urlString,
              /* out */ bool& outIsHttps,
              /* out */ unsigned int& outPort,
              /* out */ std::string& outHostName,
              /* out */ std::string& outExtra);
